image: python:3.7.8-slim-buster

cache:
  paths:
    - .eggs/
    - .cache/pip/

stages:
  - qa
  - publish

test:
  stage: qa
  script:
    - export PYTHONPATH=.:./src
    - pip install --upgrade pip
    - pip install --cache-dir $CI_PROJECT_DIR/.cache/pip -r requirements/package.txt
    - pip install --cache-dir $CI_PROJECT_DIR/.cache/pip -r requirements/test.txt
    - pytest

pylint:
  stage: qa
  script:
    - export PYTHONPATH=.:./src
    - pip install --upgrade pip
    - pip install --cache-dir $CI_PROJECT_DIR/.cache/pip -r requirements/package.txt
    - pip install --cache-dir $CI_PROJECT_DIR/.cache/pip -r requirements/test.txt
    - pylint src/morphosis test/test_morphosis

pypi:
  stage: publish
  script:
    - apt-get update && apt-get -y install git make
    - git describe --tags > VERSION
    - cat VERSION
    - pip install --upgrade pip
    - pip install --cache-dir $CI_PROJECT_DIR/.cache/pip -r requirements/publish.txt
    - make build
    - make publish
  only:
    refs:
      - tags
